"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var React = require("react");
// tslint:disable-next-line ter-max-len
function formoStateHandler(Component) {
    return _a = (function (_super) {
            __extends(FormoStateHandler, _super);
            function FormoStateHandler() {
                var _this = _super !== null && _super.apply(this, arguments) || this;
                _this.state = {
                    fields: _this.props.fields
                };
                _this.onChange = function (fields, meta) {
                    var _a = _this.props.onChange, onChange = _a === void 0 ? lodash_1.noop : _a; // apparently defaultProps doesn't work
                    _this.setState({
                        fields: fields
                        // TODO should this be used in `cwrp` to avoid useless setState/(or to optimize componentShouldUpdate)?
                        // oldFields: this.state.fields
                    }, function () {
                        onChange(fields, meta);
                    });
                };
                _this.mergeFields = function (fieldsFromProps, fieldsFromState) {
                    // the source of truths of which fields are in the form
                    // come from the props (they can be removed, or new ones added)
                    return lodash_1.mapValues(fieldsFromProps, function (_, fieldName) { return (__assign({}, fieldsFromState[fieldName], fieldsFromProps[fieldName] // it would be the first argument, but for symmetry...
                    )); });
                };
                return _this;
            }
            FormoStateHandler.prototype.componentWillReceiveProps = function (_a) {
                var fields = _a.fields;
                var mergedFields = this.mergeFields(fields, this.state.fields);
                this.setState({
                    fields: mergedFields
                });
            };
            FormoStateHandler.prototype.getLocals = function (props) {
                var _a = this, onChange = _a.onChange, fields = _a.state.fields;
                return __assign({ validations: {} }, props, { fields: fields,
                    onChange: onChange });
            };
            FormoStateHandler.prototype.render = function () {
                return React.createElement(Component, __assign({}, this.getLocals(this.props)));
            };
            return FormoStateHandler;
        }(React.PureComponent)),
        _a.displayName = "FormoStateHandler" + (Component.displayName || ''),
        _a;
    var _a;
}
exports.default = formoStateHandler;
