"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var lodash_2 = require("lodash");
var lodash_3 = require("lodash");
var lodash_4 = require("lodash");
var lodash_5 = require("lodash");
var lodash_6 = require("lodash");
var lodash_7 = require("lodash");
var lodash_8 = require("lodash");
var lodash_9 = require("lodash");
var lodash_10 = require("lodash");
var lodash_11 = require("lodash");
var React = require("react");
var formo_state_handler_1 = require("./formo-state-handler");
var set = function (key) { return function (value) { return function (object) {
    return (__assign({}, object, (_a = {}, _a[key] = value, _a)));
    var _a;
}; }; };
var firstDefined = function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return lodash_2.find(args, function (x) { return x !== void 0; });
};
var innerSet = function (object) { return function (firstKey) { return function (secondKey) { return function (value) {
    var newFirstKeyObject = set(secondKey)(value)(object[firstKey]);
    return set(firstKey)(newFirstKeyObject)(object);
}; }; }; };
var updateValue = function (fields) { return function (fieldName) { return function (value) {
    return innerSet(fields)(fieldName)('value')(value);
}; }; };
var setActive = function (fields) { return function (fieldName) {
    // set all fields to active: false
    var activeFalseFields = lodash_7.mapValues(fields, set('active')(false));
    // set fieldName field to active: true
    return innerSet(activeFalseFields)(fieldName)('active')(true);
}; };
var touch = function (fields) { return function (fieldName) {
    return innerSet(fields)(fieldName)('touched')(true);
}; };
var unsetActive = function (fields) { return function (fieldName) {
    // set the field to active: false
    var deactivated = innerSet(fields)(fieldName)('active')(false);
    // set the field to touched: true
    return touch(deactivated)(fieldName);
}; };
var clearValue = function (fields) { return function (fieldName) {
    return innerSet(fields)(fieldName)('value')(undefined);
}; };
var clearValues = function (fields) {
    return lodash_7.mapValues(fields, function (field) { return set('value')(field.initialValue)(field); });
};
var touchAll = function (fields) {
    return lodash_7.mapValues(fields, set('touched')(true));
};
var formo = function (Component) {
    var Formo = (function (_super) {
        __extends(Formo, _super);
        function Formo() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.evalValidations = function (validations, value, otherValues) {
                var evaluated = lodash_7.mapValues(validations, function (validationFn) { return validationFn(value, otherValues); });
                var validationErrors = lodash_10.pickBy(evaluated, function (x) { return x === false; });
                return lodash_7.mapValues({ validationErrors: validationErrors }, Object.keys);
            };
            _this.getFieldsValues = function (fields) { return lodash_7.mapValues(fields, function (field) { return (__assign({}, field, { initialValue: firstDefined(field.initialValue), value: firstDefined(field.value, field.initialValue) })); }); };
            _this.fieldsWithValidations = function (fields) {
                return lodash_7.mapValues(fields, function (field, fieldName) {
                    var fieldValidations = fieldName && _this.props.validations ? _this.props.validations[fieldName] : {};
                    var validationErrors = _this.evalValidations(fieldValidations, field.value, lodash_7.mapValues(fields, 'value')).validationErrors;
                    var isValid = validationErrors.length === 0;
                    return __assign({}, lodash_8.omit(field, 'validations'), { validationErrors: validationErrors,
                        isValid: isValid });
                });
            };
            _this.onChange = function (newFields) {
                var _a = _this, fieldsAreChanged = _a.fieldsAreChanged, fieldsWithValidations = _a.fieldsWithValidations, enforceOnlyOneActive = _a.enforceOnlyOneActive;
                var propsKeysToOmit = ['validationErrors', 'isValid', 'isChanged'];
                var newFieldsValues = _this.getFieldsValues(newFields);
                var fields = lodash_7.mapValues(newFieldsValues, function (x) { return lodash_8.omit(x, propsKeysToOmit); });
                var richFields = lodash_4.flowRight(fieldsAreChanged, fieldsWithValidations, enforceOnlyOneActive)(fields);
                var meta = __assign({}, lodash_7.mapValues(richFields, function (x) { return lodash_9.pick(x, propsKeysToOmit); }), { form: _this.makeForm(fields, _this.props.validations) });
                _this.props.onChange(fields, meta);
            };
            _this.updateValue = function (fieldName) { return function (value) {
                _this.onChange(updateValue(_this.props.fields)(fieldName)(value));
            }; };
            _this.setActive = function (fieldName) { return function () {
                _this.onChange(setActive(_this.props.fields)(fieldName));
            }; };
            _this.touch = function (fieldName) { return function () {
                _this.onChange(touch(_this.props.fields)(fieldName));
            }; };
            _this.unsetActive = function (fieldName) { return function () {
                _this.onChange(unsetActive(_this.props.fields)(fieldName));
            }; };
            _this.set = function (fieldName) { return function (prop, value) {
                _this.onChange(innerSet(_this.props.fields)(fieldName)(prop)(value));
            }; };
            _this.clearValue = function (fieldName) { return function () {
                _this.onChange(clearValue(_this.props.fields)(fieldName));
            }; };
            _this.clearValues = function () {
                _this.onChange(clearValues(_this.props.fields));
            };
            _this.touchAll = function () {
                _this.onChange(touchAll(_this.props.fields));
            };
            _this.fieldsWithSetters = function (fields) {
                return lodash_7.mapValues(fields, function (field, fieldName) {
                    var setters = {
                        clear: _this.clearValue(fieldName),
                        set: _this.set(fieldName),
                        setActive: _this.setActive(fieldName),
                        touch: _this.touch(fieldName),
                        unsetActive: _this.unsetActive(fieldName),
                        update: _this.updateValue(fieldName)
                    };
                    return __assign({}, field, setters);
                });
            };
            _this.isChanged = function (_a) {
                var value = _a.value, initialValue = _a.initialValue;
                var similarlyNil = ['', undefined, null];
                return (!lodash_6.isEqual(value, initialValue) &&
                    !(lodash_5.includes(similarlyNil, value) && lodash_5.includes(similarlyNil, initialValue)));
            };
            _this.fieldsAreChanged = function (fields) {
                return lodash_7.mapValues(fields, function (field) { return (__assign({}, field, { isChanged: _this.isChanged(field) })); });
            };
            _this.formIsChanged = function (fields) { return lodash_11.some(fields, _this.isChanged); };
            _this.formIsValid = function (fields, validationErrors) {
                return lodash_1.every(fields, 'isValid') && (validationErrors.length === 0);
            };
            _this.enforceOnlyOneActive = function (fields) {
                var firstFieldActive = lodash_3.findKey(fields, 'active');
                return lodash_7.mapValues(fields, function (field, fieldName) { return (__assign({}, field, { active: fieldName === firstFieldActive })); });
            };
            _this.fieldsAreTouched = function (fields) {
                return lodash_7.mapValues(fields, function (field) { return (__assign({}, field, { touched: !!field.touched })); });
            };
            _this.makeForm = function (fields, validations) {
                var parsedFields = lodash_4.flowRight(_this.fieldsWithValidations, _this.enforceOnlyOneActive, _this.fieldsAreChanged, _this.getFieldsValues)(fields);
                var formValidation = validations && validations.form || {};
                var validationErrors = _this.evalValidations(formValidation, lodash_7.mapValues(parsedFields, 'value')).validationErrors;
                return {
                    allTouched: lodash_1.every(fields, 'touched'),
                    isChanged: _this.formIsChanged(fields),
                    isValid: _this.formIsValid(fields, validationErrors),
                    touched: lodash_11.some(fields, 'touched'),
                    validationErrors: validationErrors
                };
            };
            _this.formWithSetters = function (form) { return (__assign({}, form, { clearValues: _this.clearValues, touchAll: _this.touchAll })); };
            return _this;
        }
        Formo.prototype.getLocals = function (props) {
            var otherProps = lodash_8.omit(props, ['onChange', 'fields', 'validations']);
            var fields = lodash_4.flowRight(this.fieldsAreTouched, this.fieldsWithSetters, this.fieldsWithValidations, this.enforceOnlyOneActive, this.fieldsAreChanged, this.getFieldsValues)(props.fields);
            var form = lodash_4.flowRight(this.formWithSetters, this.makeForm)(props.fields, props.validations);
            return __assign({}, otherProps, fields, { form: form });
        };
        Formo.prototype.render = function () {
            return React.createElement(Component, __assign({}, this.getLocals(this.props)));
        };
        return Formo;
    }(React.PureComponent));
    Formo.displayName = "Formo" + (Component.displayName || '');
    return formo_state_handler_1.default(Formo);
};
exports.default = formo;
